package app;

public class App {
    public static void main(String[] args) throws Exception {
        /** Aufgabe 1.1 - 1.3 */
        System.out.println("++++ Aufgabe 1.1 - 1.3 ++++");
        MyStack<String> stack = new MyStack<String>();
        stack.push("hello");
        stack.push("world");
        stack.push("123");
        System.out.println(stack.pop());
        System.out.println(stack.pop());
        System.out.println(stack.pop());

        /** Aufgabe 1.4 */
        System.out.println("++++ Aufgabe 1.4 ++++");
        tokenizeAndCalc("( 2 + 3 )");
        tokenizeAndCalc("( 3 - ( 2 * 3 ) )");
        tokenizeAndCalc("( ( 5 * 4 ) - ( 2 * ( 3 / 4 ) ) )");
    }

    private static void tokenizeAndCalc(String in) {
        MyStack<String> stack = new MyStack<String>();
        int i = 0;
        while (i < in.length()) {
            String a = "";
            // Catch last case if space is missing
            if (i + 1 == in.length())
                a = "" + in.charAt(i);
            else
                while (in.charAt(i) != ' ') {
                    a = a + in.charAt(i);
                    i++;
                }
            stack.push(a);
            i++;
        }
        stack.reverse(); // Reverse stack due to limitations

        MyStack<String> opStack = new MyStack<String>();
        MyStack<Float> numStack = new MyStack<Float>();
        while (!stack.isEmpty()) {
            String curr = stack.pop();
            if (curr.matches("-?\\d+"))
                numStack.push(Float.parseFloat(curr));
            else if (curr.matches("\\*|\\+|\\-|\\/"))
                opStack.push(curr);
            else if (curr.equals(")")) {
                String currOp = opStack.pop();
                float num1 = numStack.pop();
                float num2 = numStack.pop();
                switch (currOp) {
                case "+":
                    numStack.push(num2 + num1);
                    break;
                case "-":
                    numStack.push(num2 - num1);
                    break;
                case "*":
                    numStack.push(num2 * num1);
                    break;
                case "/":
                    numStack.push(num2 / num1);
                    break;
                }
            }
        }
        System.out.println(in);
        System.out.println("Ergebnis: " + numStack.pop());
    }

}
